      PROGRAM MSTART 
*
*  Sample code for multistart.
*  Illustrates the use of subroutine optima.
*
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      PARAMETER ( N = 2, M = 0 )
      DIMENSION XP(N), XLL(N), XRL(N), IXAT(N), ICODE(4)
      CHARACTER*10 FINP, FOUT
*
*  The input Merlin-instructions reside in file: in.dat
*  Merlin's output will be disposed to: /dev/null   (Trash file)
      DATA FINP / 'in.dat' /
      DATA FOUT / '/dev/null' /
*
*  Instruct Merlin to initialize the parameters from array XP,
*  and to ignore the input for lower bounds, upper bounds and fix-status.
      DATA ICODE / 1, 0, 0, 0 /
*
      DO 2 J=1,10
*  Fill the XP array with random numbers in the range (-7,7)
*  Routine RANM() is provided by Merlin.
         DO 1 I=1,N
            XP(I) = 7*(2*RANM()-1)
1        CONTINUE
*  Perform local optimization. 
         CALL OPTIMA(N,M,XP,XV,XLL,XRL,IXAT,ICODE,
     &               FINP,FOUT,GRMS,NF,NG,NH,NJ)
         IF (J.EQ.1) WRITE (*,70)
         WRITE (*,71) J, NF, NG, XV, (XP(I),I=1,N), GRMS
2     CONTINUE
70    FORMAT (3X,'J',4x,'FE',4X,'GE',7X,'VAL',11X,'. . . . XP . . . .',
     &        10x,'GRMS')
71    FORMAT (1X,I3,1x,I5,1X,I5,2X,D12.5,1X,10(2X,D12.5))
      END
